﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
  using System;

  using HeuristicLab.Algorithms.PushGP.Data.Pool;

  public class PooledPushGpInterpreter : PushGpInterpreter, IRecyclable, IDisposable {

    private readonly PushGpInterpreterPool container;

    public PooledPushGpInterpreter(PushGpInterpreterPool container, Configuration config)
      : base(config) {
      this.container = container;
    }

    void IRecyclable.Recycle() {
      this.Reset();
      this.Configuration = this.container.Configuration;
    }

    public void Dispose() {
      this.container.Free(this);
    }
  }
}
